
/* Server Version: WI-V6.3.5.4926 Firebird 1.5.  ODS Version: 10.1. SET NAMES WIN1251;

SET SQL DIALECT 3;

RECONNECT;*/


ALTER TABLE "Sections" DROP CONSTRAINT "FK_Sections_OwnerGUID";

COMMIT;
RECONNECT;

ALTER TABLE "Sections" DROP CONSTRAINT "FK_Sections";

COMMIT;
RECONNECT;

ALTER TABLE RES DROP CONSTRAINT "FK_RES_OwnerGUID";

COMMIT;
RECONNECT;

ALTER TABLE RES DROP CONSTRAINT FK_RES;

COMMIT;
RECONNECT;

ALTER TABLE PES DROP CONSTRAINT "FK_PES_OwnerGUID";

COMMIT;
RECONNECT;

ALTER TABLE PES DROP CONSTRAINT FK_PES;

COMMIT;
RECONNECT;

ALTER TABLE "Nodes" DROP CONSTRAINT "FK_Nodes_OwnerGUID";

COMMIT;
RECONNECT;

ALTER TABLE "Nodes" DROP CONSTRAINT "FK_Nodes_FiderIdent";

COMMIT;
RECONNECT;

ALTER TABLE "Lines" DROP CONSTRAINT "FK_Lines_OwnerGUID";

COMMIT;
RECONNECT;

ALTER TABLE "Lines" DROP CONSTRAINT "FK_Lines_FiderIdent";

COMMIT;
RECONNECT;

ALTER TABLE "Fiders" DROP CONSTRAINT "FK_Fiders_OwnerGUID";

COMMIT;
RECONNECT;

ALTER TABLE "Fiders" DROP CONSTRAINT "FK_Fiders";

COMMIT;
RECONNECT;

ALTER TABLE "Centers" DROP CONSTRAINT "FK_Centers_OwnerGUID";

COMMIT;
RECONNECT;

ALTER TABLE "Centers" DROP CONSTRAINT "FK_Centers";

COMMIT;
RECONNECT;

/* Drop Constraints... */
RECONNECT;

ALTER TABLE "AOEnergo" DROP CONSTRAINT "PK_AOEnergo";

COMMIT;

RECONNECT;

ALTER TABLE "Centers" DROP CONSTRAINT "PK_Centers";

COMMIT;

RECONNECT;

ALTER TABLE "Fiders" DROP CONSTRAINT "PK_Fiders";

COMMIT;

ALTER TABLE "InitParams" DROP CONSTRAINT "CHK_InitParams_Param";

COMMIT;

ALTER TABLE "MeterCount" DROP CONSTRAINT "PK_MeterCount1";

COMMIT;

RECONNECT;

ALTER TABLE PES DROP CONSTRAINT PK_PES;

COMMIT;

RECONNECT;

ALTER TABLE RES DROP CONSTRAINT PK_RES;

COMMIT;

RECONNECT;

ALTER TABLE "Sections" DROP CONSTRAINT "PK_Sections";

COMMIT;


/* Create Domain... */
CREATE DOMAIN DECIMAL_5_4_1 AS DECIMAL(5,4) CHECK(Value IS NULL or Value>=0 and Value<=1);

COMMIT;
CREATE DOMAIN DECIMAL_5_4_1_NOT_NULL AS DECIMAL(5,4) NOT NULL CHECK(Value>=0 and Value<=1);

COMMIT;
CREATE DOMAIN DECIMAL_6_5 AS DECIMAL(6,5) CHECK(Value IS NULL or Value>=0 and Value<10);

COMMIT;
CREATE DOMAIN DECIMAL_6_5_NOT_NULL AS DECIMAL(6,5) NOT NULL CHECK(Value>=0 and Value<=10);

COMMIT;
CREATE DOMAIN "DECIMAL_Temperature_NOT_NULL" AS DECIMAL(5,2) DEFAULT 20 CHECK((Value>=-70) AND (Value<=70));

COMMIT;
CREATE DOMAIN "Name100_NOT_NULL" AS VARCHAR(100) CHARACTER SET WIN1251 NOT NULL COLLATE PXW_CYRL;

COMMIT;
/* Empty trigger body before drop... */
SET TERM ^ ;

ALTER TRIGGER "CentersBeforeUpdateTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
/* Empty trigger body before drop... */
ALTER TRIGGER "FiderBeforeUpdateTriggerTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
/* Empty trigger body before drop... */
ALTER TRIGGER "LinesBeforeUpdateTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
/* Empty trigger body before drop... */
ALTER TRIGGER "PESBeforeUpdateTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
/* Empty trigger body before drop... */
ALTER TRIGGER "RESBeforeUpdateTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
/* Empty trigger body before drop... */
ALTER TRIGGER "SectionsBeforeUpdateTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
/* Alter Procedure (Before Drop)... */
ALTER PROCEDURE "AOEnergoInsertProc"("Name" VARCHAR(50) CHARACTER SET WIN1251)
 RETURNS("Ident" SMALLINT)
 AS
 BEGIN EXIT; END
^

COMMIT ^
ALTER PROCEDURE "CenterInsertProc"("AOEnergo" SMALLINT,
PES SMALLINT,
RES SMALLINT,
"Name" VARCHAR(50) CHARACTER SET WIN1251)
 RETURNS("Ident" SMALLINT)
 AS
 BEGIN EXIT; END
^

COMMIT ^
ALTER PROCEDURE "FiderInsertProc"("AOEnergo" SMALLINT,
PES SMALLINT,
RES SMALLINT,
"Center" SMALLINT,
"Section" SMALLINT,
"Name" VARCHAR(50) CHARACTER SET WIN1251)
 RETURNS("FiderIdent" INTEGER)
 AS
 BEGIN EXIT; END
^

COMMIT ^
ALTER PROCEDURE "FreeAOEnergoIdent"(AIDENT SMALLINT)
 AS
 BEGIN EXIT; END
^

COMMIT ^
ALTER PROCEDURE "FreeCenterIdent"("AOEnergo" SMALLINT,
PES SMALLINT,
RES SMALLINT,
"AIdent" SMALLINT)
 AS
 BEGIN EXIT; END
^

COMMIT ^
ALTER PROCEDURE "FreeFiderIdent"("AOEnergo" SMALLINT,
PES SMALLINT,
RES SMALLINT,
"Center" SMALLINT,
"Section" SMALLINT,
"AIdent" SMALLINT)
 AS
 BEGIN EXIT; END
^

COMMIT ^
ALTER PROCEDURE "FreePesIdent"("AOEnergo" SMALLINT,
"AIdent" SMALLINT)
 AS
 BEGIN EXIT; END
^

COMMIT ^
ALTER PROCEDURE "FreeResIdent"("AOEnergo" SMALLINT,
PES SMALLINT,
"AIdent" SMALLINT)
 AS
 BEGIN EXIT; END
^

COMMIT ^
ALTER PROCEDURE "FreeSectionIdent"("AOEnergo" SMALLINT,
PES SMALLINT,
RES SMALLINT,
"Center" SMALLINT,
"AIdent" SMALLINT)
 AS
 BEGIN EXIT; END
^

COMMIT ^
ALTER PROCEDURE "GetNewAOEnergoIdent" RETURNS("Ident" SMALLINT)
 AS
 BEGIN EXIT; END
^

COMMIT ^
ALTER PROCEDURE "GetNewCenterIdent"("AOEnergo" SMALLINT,
PES SMALLINT,
RES SMALLINT)
 RETURNS("Ident" SMALLINT)
 AS
 BEGIN EXIT; END
^

COMMIT ^
ALTER PROCEDURE "GetNewFiderIdent"("AOEnergo" SMALLINT,
PES SMALLINT,
RES SMALLINT,
"Center" SMALLINT,
"Section" SMALLINT)
 RETURNS("Ident" SMALLINT)
 AS
 BEGIN EXIT; END
^

COMMIT ^
ALTER PROCEDURE "GetNewPesIdent"("AOEnergo" SMALLINT)
 RETURNS("Ident" SMALLINT)
 AS
 BEGIN EXIT; END
^

COMMIT ^
ALTER PROCEDURE "GetNewResIdent"("AOEnergo" SMALLINT,
PES SMALLINT)
 RETURNS("Ident" SMALLINT)
 AS
 BEGIN EXIT; END
^

COMMIT ^
ALTER PROCEDURE "GetNewSectionIdent"("AOEnergo" SMALLINT,
PES SMALLINT,
RES SMALLINT,
"Center" SMALLINT)
 RETURNS("Ident" SMALLINT)
 AS
 BEGIN EXIT; END
^

COMMIT ^
ALTER PROCEDURE "PESInsertProc"("AOEnergo" SMALLINT,
"Name" VARCHAR(50) CHARACTER SET WIN1251)
 RETURNS("Ident" SMALLINT)
 AS
 BEGIN EXIT; END
^

COMMIT ^
ALTER PROCEDURE "RESInsertProc"("AOEnergo" SMALLINT,
PES SMALLINT,
"Name" VARCHAR(50) CHARACTER SET WIN1251)
 RETURNS("Ident" SMALLINT)
 AS
 BEGIN EXIT; END
^

COMMIT ^
ALTER PROCEDURE "SectionInsertProc"("AOEnergo" SMALLINT,
PES SMALLINT,
RES SMALLINT,
"Center" SMALLINT,
"Name" VARCHAR(50) CHARACTER SET WIN1251)
 RETURNS("Ident" SMALLINT)
 AS
 BEGIN EXIT; END
^

COMMIT ^

/* Drop Procedure... */
SET TERM ; ^

DROP PROCEDURE "AOEnergoInsertProc";

COMMIT;
DROP PROCEDURE "CenterInsertProc";

COMMIT;
DROP PROCEDURE "FiderInsertProc";

COMMIT;
DROP PROCEDURE "FreeAOEnergoIdent";

COMMIT;
DROP PROCEDURE "FreeCenterIdent";

COMMIT;
DROP PROCEDURE "FreeFiderIdent";

COMMIT;
DROP PROCEDURE "FreePesIdent";

COMMIT;
DROP PROCEDURE "FreeResIdent";

COMMIT;
DROP PROCEDURE "FreeSectionIdent";

COMMIT;
SET TERM ^ ;

ALTER TRIGGER "AOEnergoInsertTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
SET TERM ; ^

DROP PROCEDURE "GetNewAOEnergoIdent";

COMMIT;
SET TERM ^ ;

ALTER TRIGGER "CenterInsertTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
SET TERM ; ^

DROP PROCEDURE "GetNewCenterIdent";

COMMIT;
SET TERM ^ ;

ALTER TRIGGER "FiderInsertTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
SET TERM ; ^

DROP PROCEDURE "GetNewFiderIdent";

COMMIT;
SET TERM ^ ;

ALTER TRIGGER "PESInsertTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
SET TERM ; ^

DROP PROCEDURE "GetNewPesIdent";

COMMIT;
SET TERM ^ ;

ALTER TRIGGER "ResInsertTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
SET TERM ; ^

DROP PROCEDURE "GetNewResIdent";

COMMIT;
SET TERM ^ ;

ALTER TRIGGER "SectionsInsertTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
SET TERM ; ^

DROP PROCEDURE "GetNewSectionIdent";

COMMIT;
DROP PROCEDURE "PESInsertProc";

COMMIT;
DROP PROCEDURE "RESInsertProc";

COMMIT;
DROP PROCEDURE "SectionInsertProc";

COMMIT;

/* Drop Trigger... */
DROP TRIGGER "CentersBeforeUpdateTrigger";

COMMIT;
DROP TRIGGER "FiderBeforeUpdateTriggerTrigger";

COMMIT;
DROP TRIGGER "LinesBeforeUpdateTrigger";

COMMIT;
DROP TRIGGER "PESBeforeUpdateTrigger";

COMMIT;
DROP TRIGGER "RESBeforeUpdateTrigger";

COMMIT;
DROP TRIGGER "SectionsBeforeUpdateTrigger";

COMMIT;

/* Drop Index... */
RECONNECT;

DROP INDEX "idxFiderGUID";

COMMIT;
RECONNECT;

DROP INDEX "idxSectionsUnom";

COMMIT;

ALTER TABLE "LVPResults" ADD T DECIMAL_7_3;

COMMIT;
ALTER TABLE "LVPSamples" ADD "TypeCalc" "YesNo";

COMMIT;
ALTER TABLE "LVPSamples" ADD T DECIMAL_7_3;

COMMIT;
ALTER TABLE "LVPSamples" ADD "tau" DECIMAL_5_4_1;

COMMIT;
ALTER TABLE "LVPTPInfo" ADD "TypeCalc" "YesNo";

COMMIT;
ALTER TABLE "LVPTPInfo" ADD T DECIMAL_7_3;

COMMIT;
ALTER TABLE "LVPTPInfo" ADD "tau" DECIMAL_5_4_1;

COMMIT;
ALTER TABLE "LVWSamples" ADD "TypeCalc" "YesNo";

COMMIT;
ALTER TABLE "LVWTPInfo" ADD "TypeCalc" "YesNo";

COMMIT;
ALTER TABLE "PResults" ADD T DECIMAL_7_3_NOT_NULL;

COMMIT;
ALTER TABLE "PResults" ADD "WeatherConditions" INTEGER;

COMMIT;
ALTER TABLE "PSamples" ADD "SampleType" SMALLINT;

COMMIT;
ALTER TABLE "PSamples" ADD T DECIMAL_7_3;

COMMIT;
ALTER TABLE "PSamples" ADD "tau" DECIMAL_5_4_1;

COMMIT;
ALTER TABLE "PSamples" ADD "WeatherConditions" INTEGER;

COMMIT;
ALTER TABLE "Rastr_Days" ALTER "1" TO "Work1" ;
ALTER TABLE "Rastr_Days" ALTER "2" TO "Work2" ;
ALTER TABLE "Rastr_Days" ALTER "3" TO "Work3" ;
ALTER TABLE "Rastr_Days" ALTER "4" TO "Work4" ;
ALTER TABLE "Rastr_Days" ALTER "5" TO "Work5" ;
ALTER TABLE "Rastr_Days" ALTER "6" TO "Work6" ;
ALTER TABLE "Rastr_Days" ALTER "7" TO "Work7" ;
ALTER TABLE "Rastr_Days" ALTER "8" TO "Work8" ;
ALTER TABLE "Rastr_Days" ALTER "9" TO "Work9" ;
ALTER TABLE "Rastr_Days" ALTER "10" TO "Work10" ;
ALTER TABLE "Rastr_Days" ALTER "11" TO "Work11" ;
ALTER TABLE "Rastr_Days" ALTER "12" TO "Work12" ;

/*ALTER TABLE "Rastr_Days" ADD "Work1" SMALLINT;

COMMIT;
ALTER TABLE "Rastr_Days" ADD "Work2" SMALLINT;

COMMIT;
ALTER TABLE "Rastr_Days" ADD "Work3" SMALLINT;

COMMIT;
ALTER TABLE "Rastr_Days" ADD "Work4" SMALLINT;

COMMIT;
ALTER TABLE "Rastr_Days" ADD "Work5" SMALLINT;

COMMIT;
ALTER TABLE "Rastr_Days" ADD "Work6" SMALLINT;

COMMIT;
ALTER TABLE "Rastr_Days" ADD "Work7" SMALLINT;

COMMIT;
ALTER TABLE "Rastr_Days" ADD "Work8" SMALLINT;

COMMIT;
ALTER TABLE "Rastr_Days" ADD "Work9" SMALLINT;

COMMIT;
ALTER TABLE "Rastr_Days" ADD "Work10" SMALLINT;

COMMIT;
ALTER TABLE "Rastr_Days" ADD "Work11" SMALLINT;

COMMIT;
ALTER TABLE "Rastr_Days" ADD "Work12" SMALLINT;    */

COMMIT;
ALTER TABLE "SamplesDates" ADD "Temperature" "DECIMAL_Temperature";

COMMIT;
ALTER TABLE "SamplesDates" ADD "WeatherConditions" INTEGER;

COMMIT;
ALTER TABLE "WResults" ADD "WeatherConditions" INTEGER;

COMMIT;
ALTER TABLE "WResultsA" ADD "WeatherConditions" INTEGER;

COMMIT;
ALTER TABLE "WSamples" ADD "WeatherConditions" INTEGER;

COMMIT;
/* Drop Fields on Table... */
ALTER TABLE "AOEnergo" DROP "Ident";

COMMIT;
RECONNECT;

DROP INDEX "idxCenterName";

COMMIT;
ALTER TABLE "Centers" DROP "AOEnergo";

COMMIT;
ALTER TABLE "Centers" DROP PES;

COMMIT;
ALTER TABLE "Centers" DROP RES;

COMMIT;
ALTER TABLE "Centers" DROP "Ident";

COMMIT;
SET TERM ^ ;

ALTER TRIGGER "NodesBeforeInsertTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
ALTER TRIGGER "LinesBeforeInsertTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
ALTER TRIGGER "NodePResultsDeleteTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
ALTER TRIGGER "NodeWResultsDeleteTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
ALTER TRIGGER "NodeWResultsADeleteTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
ALTER TRIGGER "NodesBeforeUpdateTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
SET TERM ; ^

ALTER TABLE "Fiders" DROP "FiderIdent";

COMMIT;
RECONNECT;

DROP INDEX "idxFiderName";

COMMIT;
ALTER TABLE "Fiders" DROP "AOEnergo";

COMMIT;
ALTER TABLE "Fiders" DROP PES;

COMMIT;
ALTER TABLE "Fiders" DROP RES;

COMMIT;
ALTER TABLE "Fiders" DROP "Center";

COMMIT;
ALTER TABLE "Fiders" DROP "Section";

COMMIT;
ALTER TABLE "Fiders" DROP "Ident";

COMMIT;
/* Empty CheckSavedFiderProc for drop Lines(FiderIdent) */
SET TERM ^ ;

ALTER PROCEDURE "CheckSavedFiderProc"(AGUID INTEGER)
 AS
 BEGIN EXIT; END
^

COMMIT ^
SET TERM ; ^

RECONNECT;

DROP INDEX "idxLinesTabOrder";

COMMIT;
ALTER TABLE "Lines" DROP "FiderIdent";

/* COMMIT;
ALTER TABLE "LVPResults" DROP "Tmax";*/

COMMIT;
ALTER TABLE "LVWResultsB" DROP "kn";

COMMIT;
RECONNECT;

DROP INDEX "idxNodesTabOrder";

COMMIT;
SET TERM ^ ;

ALTER TRIGGER "ExLinesBeforeInsertTrigger"
 AS Declare variable I integer;
BEGIN I = 0; END
^

COMMIT ^
SET TERM ; ^

ALTER TABLE "Nodes" DROP "FiderIdent";

COMMIT;
RECONNECT;

DROP INDEX "idxPESName";

COMMIT;
ALTER TABLE PES DROP "AOEnergo";

COMMIT;
ALTER TABLE PES DROP "Ident";
/*
COMMIT;
ALTER TABLE "Rastr_Days" DROP "1";

COMMIT;
ALTER TABLE "Rastr_Days" DROP "2";

COMMIT;
ALTER TABLE "Rastr_Days" DROP "3";

COMMIT;
ALTER TABLE "Rastr_Days" DROP "4";

COMMIT;
ALTER TABLE "Rastr_Days" DROP "5";

COMMIT;
ALTER TABLE "Rastr_Days" DROP "6";

COMMIT;
ALTER TABLE "Rastr_Days" DROP "7";

COMMIT;
ALTER TABLE "Rastr_Days" DROP "8";

COMMIT;
ALTER TABLE "Rastr_Days" DROP "9";

COMMIT;
ALTER TABLE "Rastr_Days" DROP "10";

COMMIT;
ALTER TABLE "Rastr_Days" DROP "11";

COMMIT;
ALTER TABLE "Rastr_Days" DROP "12";   */

COMMIT;
RECONNECT;

DROP INDEX "idxRESName";

COMMIT;
ALTER TABLE RES DROP "AOEnergo";

COMMIT;
ALTER TABLE RES DROP PES;

COMMIT;
ALTER TABLE RES DROP "Ident";

COMMIT;
RECONNECT;

DROP INDEX "idxSectionName";

COMMIT;
ALTER TABLE "Sections" DROP "AOEnergo";

COMMIT;
ALTER TABLE "Sections" DROP PES;

COMMIT;
ALTER TABLE "Sections" DROP RES;

COMMIT;
ALTER TABLE "Sections" DROP "Center";

COMMIT;
ALTER TABLE "Sections" DROP "Ident";

COMMIT;

/* Drop UDF */
DROP EXTERNAL FUNCTION "GetFiderIdent";

COMMIT;
DROP EXTERNAL FUNCTION "GetidAOEnergo";

COMMIT;
DROP EXTERNAL FUNCTION "GetidCenter";

COMMIT;
DROP EXTERNAL FUNCTION "GetidFider";

COMMIT;
DROP EXTERNAL FUNCTION "GetidPes";

COMMIT;
DROP EXTERNAL FUNCTION "GetidRes";

COMMIT;
DROP EXTERNAL FUNCTION "GetidSection";

COMMIT;
DROP EXTERNAL FUNCTION "GetNIdent";

COMMIT;
DROP EXTERNAL FUNCTION "GetSIdent";

COMMIT;

/* Alter Domain: DECIMAL_5_4 - Check(...) */
CREATE DOMAIN IBC$TEMP AS DECIMAL(5,4) CHECK(Value IS NULL or Value>=0 and Value<=10);

COMMIT;
Update RDB$Fields set Rdb$Validation_Source =
(Select Rdb$Validation_Source from Rdb$Fields where Rdb$Field_Name='IBC$TEMP'),
Rdb$Validation_BLR =
(Select Rdb$Validation_BLR from Rdb$Fields where Rdb$Field_Name='IBC$TEMP')
where RDB$FIELD_NAME='DECIMAL_5_4';

COMMIT;
DROP DOMAIN IBC$TEMP;

COMMIT;
/* Alter Domain: DECIMAL_5_4_NOT_NULL - Check(...) */
CREATE DOMAIN IBC$TEMP AS DECIMAL(5,4) NOT NULL CHECK(Value>=0 and Value<=10);

COMMIT;
Update RDB$Fields set Rdb$Validation_Source =
(Select Rdb$Validation_Source from Rdb$Fields where Rdb$Field_Name='IBC$TEMP'),
Rdb$Validation_BLR =
(Select Rdb$Validation_BLR from Rdb$Fields where Rdb$Field_Name='IBC$TEMP')
where RDB$FIELD_NAME='DECIMAL_5_4_NOT_NULL';

COMMIT;
DROP DOMAIN IBC$TEMP;

COMMIT;
/* Alter Domain: DECIMAL_Temperature - Check(...) */
CREATE DOMAIN IBC$TEMP AS DECIMAL(5,2) CHECK(Value IS NULL OR (Value>=-70) AND (Value<=70));

COMMIT;
Update RDB$Fields set Rdb$Validation_Source =
(Select Rdb$Validation_Source from Rdb$Fields where Rdb$Field_Name='IBC$TEMP'),
Rdb$Validation_BLR =
(Select Rdb$Validation_BLR from Rdb$Fields where Rdb$Field_Name='IBC$TEMP')
where RDB$FIELD_NAME='DECIMAL_Temperature';

COMMIT;
DROP DOMAIN IBC$TEMP;

COMMIT;
/* Create Table... */
CREATE TABLE "ReferencesTypes"("Ident" "TIdent",
"Name" "Name100_NOT_NULL");

COMMIT;

CREATE TABLE "WeatherConditions"("Ident" "TIntegerIdent",
"WeatherCondition0" DECIMAL_6_2_NOT_NULL,
"WeatherCondition1" DECIMAL_6_2_NOT_NULL,
"WeatherCondition2" DECIMAL_6_2_NOT_NULL,
"WeatherCondition3" DECIMAL_6_2_NOT_NULL,
"WeatherCondition4" DECIMAL_6_2_NOT_NULL,
"WeatherCondition5" DECIMAL_6_2_NOT_NULL,
"WeatherCondition6" DECIMAL_6_2_NOT_NULL);

COMMIT;


/* Create Procedure... */
SET TERM ^ ;

CREATE PROCEDURE "GetFiderOwnerGUID"("AOEnergo" INTEGER,
PES VARCHAR(50) CHARACTER SET WIN1251,
RES VARCHAR(50) CHARACTER SET WIN1251,
"Center" VARCHAR(50) CHARACTER SET WIN1251,
"Section" VARCHAR(8) CHARACTER SET WIN1251,
"Unom" DECIMAL(10,2))
 RETURNS("OwnerGUID" INTEGER)
 AS
 BEGIN EXIT; END
^

COMMIT ^
CREATE PROCEDURE "InsertAOEnergo"("Name" VARCHAR(50) CHARACTER SET WIN1251,
"Region" SMALLINT)
 RETURNS(GUID INTEGER)
 AS
 BEGIN EXIT; END
^

COMMIT ^

SET TERM ; ^

UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1' WHERE RDB$FIELD_NAME='Performance' AND RDB$RELATION_NAME='AsynchronousMotors';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1_NOT_NULL' WHERE RDB$FIELD_NAME='k1' AND RDB$RELATION_NAME='CrownLossesMonths';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1_NOT_NULL' WHERE RDB$FIELD_NAME='k2' AND RDB$RELATION_NAME='CrownLossesMonths';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1_NOT_NULL' WHERE RDB$FIELD_NAME='k3' AND RDB$RELATION_NAME='CrownLossesMonths';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1_NOT_NULL' WHERE RDB$FIELD_NAME='k4' AND RDB$RELATION_NAME='CrownLossesMonths';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1_NOT_NULL' WHERE RDB$FIELD_NAME='k5' AND RDB$RELATION_NAME='CrownLossesMonths';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1_NOT_NULL' WHERE RDB$FIELD_NAME='k6' AND RDB$RELATION_NAME='CrownLossesMonths';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1_NOT_NULL' WHERE RDB$FIELD_NAME='k7' AND RDB$RELATION_NAME='CrownLossesMonths';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1_NOT_NULL' WHERE RDB$FIELD_NAME='k8' AND RDB$RELATION_NAME='CrownLossesMonths';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1_NOT_NULL' WHERE RDB$FIELD_NAME='k9' AND RDB$RELATION_NAME='CrownLossesMonths';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1_NOT_NULL' WHERE RDB$FIELD_NAME='k10' AND RDB$RELATION_NAME='CrownLossesMonths';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1_NOT_NULL' WHERE RDB$FIELD_NAME='k11' AND RDB$RELATION_NAME='CrownLossesMonths';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1_NOT_NULL' WHERE RDB$FIELD_NAME='k12' AND RDB$RELATION_NAME='CrownLossesMonths';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='TIdent' WHERE RDB$FIELD_NAME='Level' AND RDB$RELATION_NAME='IntStLoads';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1' WHERE RDB$FIELD_NAME='kzap' AND RDB$RELATION_NAME='IntStLoads_TCN';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1' WHERE RDB$FIELD_NAME='kzap' AND RDB$RELATION_NAME='IntStLoadsDsta';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='TIntegerIdent' WHERE RDB$FIELD_NAME='ProvodPhase' AND RDB$RELATION_NAME='LVFidersA';

COMMIT;
Update rdb$Relation_Fields set Rdb$Field_Source = 'TIntegerIdent'
WHERE RDB$FIELD_NAME='ProvodNull' AND RDB$RELATION_NAME='LVFidersA';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_CosFi' WHERE RDB$FIELD_NAME='dn' AND RDB$RELATION_NAME='LVFidersB';

COMMIT;
Update rdb$Relation_Fields set Rdb$Field_Source = 'DECIMAL_Temperature_NOT_NULL'
WHERE RDB$FIELD_NAME='Temperature' AND RDB$RELATION_NAME='LVPResults';

COMMIT;
Update rdb$Relation_Fields set Rdb$Field_Source = 'DECIMAL_Temperature_NOT_NULL'
WHERE RDB$FIELD_NAME='Temperature' AND RDB$RELATION_NAME='LVWResults';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1' WHERE RDB$FIELD_NAME='Kzap' AND RDB$RELATION_NAME='LVWSamples';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_6_5' WHERE RDB$FIELD_NAME='sqrKfg' AND RDB$RELATION_NAME='LVWSamples';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1' WHERE RDB$FIELD_NAME='Kzap' AND RDB$RELATION_NAME='LVWTPInfo';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_6_5' WHERE RDB$FIELD_NAME='sqrKfg' AND RDB$RELATION_NAME='LVWTPInfo';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1' WHERE RDB$FIELD_NAME='Kzap' AND RDB$RELATION_NAME='MainsWLoads';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_6_5' WHERE RDB$FIELD_NAME='sqrKfg' AND RDB$RELATION_NAME='MainsWLoads';

COMMIT;
Update rdb$Relation_Fields set Rdb$Field_Source = 'DECIMAL_Temperature_NOT_NULL'
WHERE RDB$FIELD_NAME='Temperature' AND RDB$RELATION_NAME='PResults';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_6_2_NOT_NULL' WHERE RDB$FIELD_NAME='F' AND RDB$RELATION_NAME='Provods';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1' WHERE RDB$FIELD_NAME='TgDelta' AND RDB$RELATION_NAME='Provods';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1' WHERE RDB$FIELD_NAME='Performance' AND RDB$RELATION_NAME='SynchronousMotors';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1' WHERE RDB$FIELD_NAME='Kzap' AND RDB$RELATION_NAME='WLoads';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_6_5' WHERE RDB$FIELD_NAME='sqrKfg' AND RDB$RELATION_NAME='WLoads';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1' WHERE RDB$FIELD_NAME='Kzap' AND RDB$RELATION_NAME='WResults';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_6_5' WHERE RDB$FIELD_NAME='sqrKfg' AND RDB$RELATION_NAME='WResults';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_6_5_NOT_NULL' WHERE RDB$FIELD_NAME='sqrKfgCalc' AND RDB$RELATION_NAME='WResults';

COMMIT;
Update rdb$Relation_Fields set Rdb$Field_Source = 'DECIMAL_Temperature_NOT_NULL'
WHERE RDB$FIELD_NAME='Temperature' AND RDB$RELATION_NAME='WResults';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1' WHERE RDB$FIELD_NAME='Kzap' AND RDB$RELATION_NAME='WResultsA';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_6_5' WHERE RDB$FIELD_NAME='sqrKfg' AND RDB$RELATION_NAME='WResultsA';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_6_5_NOT_NULL' WHERE RDB$FIELD_NAME='sqrKfgCalc' AND RDB$RELATION_NAME='WResultsA';

COMMIT;
Update rdb$Relation_Fields set Rdb$Field_Source = 'DECIMAL_Temperature_NOT_NULL'
WHERE RDB$FIELD_NAME='Temperature' AND RDB$RELATION_NAME='WResultsA';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_6_5' WHERE RDB$FIELD_NAME='sqrKfg' AND RDB$RELATION_NAME='WResultsWN';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_6_5' WHERE RDB$FIELD_NAME='sqrKfgC' AND RDB$RELATION_NAME='WResultsWN3';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_6_5' WHERE RDB$FIELD_NAME='sqrKfgH' AND RDB$RELATION_NAME='WResultsWN3';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_5_4_1' WHERE RDB$FIELD_NAME='Kzap' AND RDB$RELATION_NAME='WSamples';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='DECIMAL_6_5' WHERE RDB$FIELD_NAME='sqrKfg' AND RDB$RELATION_NAME='WSamples';

COMMIT;
/* Alter Table (Field position)... */
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=0
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='Ident';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=1
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='CosFi';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=2
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='Unom';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=3
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='F';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=4
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='NLines';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=5
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='dp';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=6
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='kzap';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=7
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='dn';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=8
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='Lma';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=9
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='Lms';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=10
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='Lmm';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=11
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='L23a';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=12
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='L23s';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=13
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='L23m';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=14
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='L1a';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=15
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='L1s';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=16
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='L1m';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=17
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='L1ia';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=18
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='L1is';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=19
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='L1im';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=20
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='L23ia';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=21
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='L23is';

COMMIT;
UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_POSITION=22
 WHERE RDB$RELATION_NAME='LVFidersB' AND RDB$FIELD_NAME='L23im';

COMMIT;
/* Drop Domain... */
DROP DOMAIN DECIMAL_6_4;

COMMIT;
DROP DOMAIN DECIMAL_6_4_NOT_NULL;

COMMIT;
DROP DOMAIN "Ident128";

COMMIT;
DROP DOMAIN "Ident32";

COMMIT;
DROP DOMAIN "Ident8";

COMMIT;
/* Alter Index (Drop, Create)... */
CREATE UNIQUE INDEX "idxCenterName" ON "Centers"("OwnerGUID","Name");

COMMIT;
CREATE UNIQUE INDEX "idxFiderName" ON "Fiders"("OwnerGUID","Name",GUID);

COMMIT;
CREATE INDEX "idxLinesTabOrder" ON "Lines"("OwnerGUID","TabOrder");

COMMIT;
CREATE INDEX "idxNodesTabOrder" ON "Nodes"("OwnerGUID","TabOrder");

COMMIT;
CREATE UNIQUE INDEX "idxPESName" ON PES("OwnerGUID","Name");

COMMIT;
CREATE UNIQUE INDEX "idxRESName" ON RES("OwnerGUID","Name");

COMMIT;
CREATE INDEX "idxSectionName" ON "Sections"("OwnerGUID","Name");

COMMIT;

/* Create Generator... */
CREATE GENERATOR "WeatherConditionIdent";

COMMIT;

/* Create Primary Key... */
ALTER TABLE "AOEnergo" ADD CONSTRAINT "PK_AOEnergo" PRIMARY KEY (GUID);

COMMIT;
ALTER TABLE "Centers" ADD CONSTRAINT "PK_Centers" PRIMARY KEY (GUID);

COMMIT;
ALTER TABLE "Fiders" ADD CONSTRAINT "PK_Fiders" PRIMARY KEY (GUID);

COMMIT;
ALTER TABLE PES ADD CONSTRAINT PK_PES PRIMARY KEY (GUID);


COMMIT;
INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES (-3,'-3');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES (-2,'-2');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES (-1,'');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES ( 0,'');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES ( 1,'  ');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES ( 2,' ');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES ( 3,' ');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES ( 4,' ');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES ( 5,'    ');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES ( 6,' ');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES ( 7,'');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES ( 8,' ');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES ( 9,' ');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES (10,' ');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES (11,' ');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES (12,'  ');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES (13,' ');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES (14,' ');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES (15,'');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES (16,'');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES (17,' ');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES (18,'  ()');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES (19,'');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES (20,' ');

INSERT INTO "ReferencesTypes" ("Ident","Name")
VALUES (21,' ');


COMMIT;
ALTER TABLE "ReferencesTypes" ADD CONSTRAINT "PK_ReferencesTypes" PRIMARY KEY ("Ident");

COMMIT;
ALTER TABLE RES ADD CONSTRAINT PK_RES PRIMARY KEY (GUID);

COMMIT;
ALTER TABLE "Sections" ADD CONSTRAINT "PK_Sections" PRIMARY KEY (GUID);

COMMIT;
ALTER TABLE "WeatherConditions" ADD CONSTRAINT "PK_WeatherConditions" PRIMARY KEY ("Ident");

COMMIT;
/* Create Unique... */
ALTER TABLE "MeterCount" ADD CONSTRAINT "UNQ_MeterCount" UNIQUE ("Unom","MeterType","OwnerGUID","SampleDate");

COMMIT;
/* Create Foreign Key... */
ALTER TABLE "Centers" ADD CONSTRAINT "FK_Centers_OwnerGUID" FOREIGN KEY ("OwnerGUID") REFERENCES RES(GUID) ON UPDATE CASCADE ON DELETE CASCADE;

COMMIT;
ALTER TABLE "Fiders" ADD CONSTRAINT "FK_Fiders_OwnerGUID" FOREIGN KEY ("OwnerGUID") REFERENCES "Sections"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;

COMMIT;
ALTER TABLE "Lines" ADD CONSTRAINT "FK_Lines_OwnerGUID" FOREIGN KEY ("OwnerGUID") REFERENCES "Fiders"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;

COMMIT;
ALTER TABLE "Nodes" ADD CONSTRAINT "FK_Nodes_OwnerGUID" FOREIGN KEY ("OwnerGUID") REFERENCES "Fiders"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;

COMMIT;
ALTER TABLE PES ADD CONSTRAINT "FK_PES_OwnerGUID" FOREIGN KEY ("OwnerGUID") REFERENCES "AOEnergo"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;

COMMIT;
ALTER TABLE "PResults" ADD CONSTRAINT "FK_PResults_WeatherConditions" FOREIGN KEY ("WeatherConditions") REFERENCES "WeatherConditions"("Ident") ON UPDATE CASCADE;

COMMIT;
ALTER TABLE "PSamples" ADD CONSTRAINT "FK_PSamples_WeatherConditions" FOREIGN KEY ("WeatherConditions") REFERENCES "WeatherConditions"("Ident") ON UPDATE CASCADE;

COMMIT;
ALTER TABLE "References" ADD CONSTRAINT "FK_References_Type" FOREIGN KEY ("ReferenceType") REFERENCES "ReferencesTypes"("Ident");

COMMIT;
ALTER TABLE RES ADD CONSTRAINT "FK_RES_OwnerGUID" FOREIGN KEY ("OwnerGUID") REFERENCES PES(GUID) ON UPDATE CASCADE ON DELETE CASCADE;

COMMIT;
ALTER TABLE "SamplesDates" ADD CONSTRAINT "FK_SamplesDates_Weather" FOREIGN KEY ("WeatherConditions") REFERENCES "WeatherConditions"("Ident") ON UPDATE CASCADE;

COMMIT;
ALTER TABLE "Sections" ADD CONSTRAINT "FK_Sections_OwnerGUID" FOREIGN KEY ("OwnerGUID") REFERENCES "Centers"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;

COMMIT;
ALTER TABLE "WResults" ADD CONSTRAINT "FK_WResults_WeatherConditions" FOREIGN KEY ("WeatherConditions") REFERENCES "WeatherConditions"("Ident") ON UPDATE CASCADE;

COMMIT;
ALTER TABLE "WResultsA" ADD CONSTRAINT "FK_WResultsA_WeatherConditions" FOREIGN KEY ("WeatherConditions") REFERENCES "WeatherConditions"("Ident") ON UPDATE CASCADE;

COMMIT;
ALTER TABLE "WSamples" ADD CONSTRAINT "FK_WSamples_WeatherConditions" FOREIGN KEY ("WeatherConditions") REFERENCES "WeatherConditions"("Ident") ON UPDATE CASCADE;

COMMIT;
/* Create Check... */
ALTER TABLE "InitParams" ADD CONSTRAINT "CHK_InitParams_Param" CHECK(("Key" between 001 and 099) and
  exists (select * from "Unom" where "Unom"."Unom"="InitParams"."Param") or /* Unom */
("Key" between 100 and 199) and ("Param"=0) or
("Key"=200) and (("Param" between 0 and 15) or ("Param" between 100 and 108))  or
 ("Key"=201) and ("Param" between 0 and 150) /* smTrNodeByKzagColors */);

COMMIT;
ALTER TABLE "InitParams" ADD CONSTRAINT "CHK_InitParams_Values" CHECK(("Key"=1) and ("Value" between 0 and 1) or /* smCosFi */
 ("Key"=2 or "Key"=3) and ("Value" between "Param"*0.8 and "Param"*1.2) or /* smUcp, smUdop*/
 ("Key"=4) and ("Value" between 1/13 and 1) or /* smKzap */
 
 ("Key" in (100,108,109,110,111) and "Value" between -2147483647 and 2147483647) or /*(smAOEnergoGUID,smVNCalc,smNNCalc,smStLoads,smMetrolog */
 ("Key"=101 and "Value" between 1 and 7) or /*smRegionIdent */
 ("Key"=102 and "Value" between 1 and 3) or /* smKdp */
 ("Key" in (103,105,112,113) and ("Value"=0 or "Value"=1)) or /* (smUseTemperature,smKuntp,smDotDisableLine,smShowPhases */
 ("Key"=104 and "Value" between -70 and 70) or /* smTemperature */
 ("Key"=106 or "Key"=107) and ("Value" between 0 and 2)  or /* smSaveDetailed,smSaveDetailedHH */
 ("Key"=5 or "Key"=200 or "Key"=201) and ("Value" between -2147483.648 and 2147483.647) /* Colors */);

COMMIT;
ALTER TABLE "WeatherConditions" ADD CONSTRAINT "CHK1_WeatherConditions" CHECK(("WeatherCondition0"+"WeatherCondition1"+"WeatherCondition2"+"WeatherCondition3")=
  ("WeatherCondition4"+"WeatherCondition5"+"WeatherCondition6"));

COMMIT;

/* Alter Procedure... */
/* Alter (CheckSavedFiderProc) */
SET TERM ^ ;

ALTER PROCEDURE "CheckSavedFiderProc"(AGUID INTEGER)
 AS
BEGIN
 insert into "GUID" (GUID)
 select L."Node1" from "Lines" L
 where L."OwnerGUID"=:AGUID and
  not exists (select * from "GUID" where "GUID".guid = L."Node1");

 insert into "GUID" (GUID)
 select L."Node2" from "Lines" L
 where L."OwnerGUID"=:AGUID and
  not exists (select * from "GUID" where "GUID".guid = L."Node2");

 insert into "Nodes" ("GUID","OwnerGUID","Transf")
 select L."Node1",L."OwnerGUID",0 from "Lines" L
 where L."OwnerGUID"=:AGUID and
  not exists (select * from "Nodes" where "Nodes".guid = L."Node1");

 insert into "Nodes" ("GUID","OwnerGUID","Transf")
 select L."Node2",L."OwnerGUID",0 from "Lines" L
 where L."OwnerGUID"=:AGUID and
  not exists (select * from "Nodes" where "Nodes".guid = L."Node2");
                                              
 insert into "Coors" (guid,x,y)
 select N.GUID,200,200 from "Nodes" N
 where N."OwnerGUID"=:AGUID and
  not exists (select * from "Coors" C where C.GUID=N.GUID);
END
^

COMMIT ^
/* Alter (CheckSavedMainsProc) */
ALTER PROCEDURE "CheckSavedMainsProc"(AIDENT INTEGER)
 AS
BEGIN
 insert into "GUID" ("GUID")
 select L."Node1" from "MainsLines" L
 where L."Mains"=:AIdent and
  not exists (select * from "GUID" where "GUID".guid = L."Node1");

 insert into "GUID" ("GUID")
 select L."Node2" from "MainsLines" L
 where L."Mains"=:AIdent and
  not exists (select * from "GUID" where "GUID".guid = L."Node2");

 insert into "MainsNodes" ("GUID","Mains","Transf")
 select L."Node1",L."Mains",0 from "MainsLines" L
 where L."Mains"=:AIdent and
  not exists (select * from "MainsNodes" where "MainsNodes".guid = L."Node1");

 insert into "MainsNodes" ("GUID","Mains","Transf")
 select L."Node2",L."Mains",0 from "MainsLines" L
 where L."Mains"=:AIdent and
  not exists (select * from "MainsNodes" where "MainsNodes".guid = L."Node2");

 insert into "Coors" (guid,x,y)
 select N."GUID",200,200 from "MainsNodes" N
 where N."Mains"=:AIdent and
  not exists (select * from "Coors" C where C."GUID"=N."GUID");
END
^

COMMIT ^
/* empty dependent procedure body */
ALTER PROCEDURE "ChildrenGUIDs"(ITEM INTEGER,
"LevelBegin" SMALLINT,
"LevelEnd" SMALLINT,
"ShowTree" SMALLINT)
 RETURNS(GUID INTEGER)
 AS
 BEGIN EXIT; END
^

COMMIT ^
/* Alter (ChildrenGUIDs) */
ALTER PROCEDURE "ChildrenGUIDs"(ITEM INTEGER,
"LevelBegin" SMALLINT,
"LevelEnd" SMALLINT,
"ShowTree" SMALLINT)
 RETURNS(GUID INTEGER)
 AS
begin
 if ("LevelBegin" is null or "LevelBegin"<1 or "LevelBegin">9)  then
 begin
  if (exists(select * from "AOEnergo" where "GUID"=:Item)) then "LevelBegin"=1;else
  if (exists(select * from "PES" where "GUID"=:Item)) then "LevelBegin"=2;else
  if (exists(select * from "RES" where "GUID"=:Item)) then "LevelBegin"=3;else
  if (exists(select * from "Centers" where "GUID"=:Item)) then "LevelBegin"=4;else
  if (exists(select * from "Sections" where "GUID"=:Item)) then "LevelBegin"=5;else
  if (exists(select * from "Fiders" where "GUID"=:Item)) then "LevelBegin"=6;else
  if (exists(select * from "Nodes" where "GUID"=:Item)) then "LevelBegin"=7;else
  if (exists(select * from "LVFiders" where "GUID"=:Item)) then "LevelBegin"=8;else
  if (exists(select * from "LVNodes" where "GUID"=:Item)) then "LevelBegin"=9;
  else exit;
 end
 if ("LevelBegin">"LevelEnd") then exit;
 GUID=Item;
 if ("ShowTree"<>0 or "LevelBegin"="LevelEnd") then suspend;
 if ("LevelBegin"<"LevelEnd") then
  if ("LevelBegin"=1) then
  begin
   for select "GUID" from "PES" where "OwnerGUID"=:Item into GUID do
   begin
    for select "GUID" from "ChildrenGUIDs"(:GUID,2,:"LevelEnd",:"ShowTree") into GUID do
     suspend;
   end
  end else
  if ("LevelBegin"=2) then
  begin
   for select "GUID" from "RES" where "OwnerGUID"=:Item into GUID do
   begin
    for select "GUID" from "ChildrenGUIDs"(:GUID,3,:"LevelEnd",:"ShowTree") into GUID do 
     suspend;
   end
  end else
  if ("LevelBegin"=3) then
  begin
   for select "GUID" from "Centers" where "OwnerGUID"=:Item into GUID do
   begin
    for select "GUID" from "ChildrenGUIDs"(:GUID,4,:"LevelEnd",:"ShowTree") into GUID do     
     suspend;
   end
  end else
  if ("LevelBegin"=4) then
  begin
   for select "GUID" from "Sections" where "OwnerGUID"=:Item into GUID do
   begin
    for select "GUID" from "ChildrenGUIDs"(:GUID,5,:"LevelEnd",:"ShowTree") into GUID do 
     suspend;
   end
  end else
  if ("LevelBegin"=5) then
  begin
   for select "GUID" from "Fiders" where "OwnerGUID"=:Item into GUID do
   begin
    for select "GUID" from "ChildrenGUIDs"(:GUID,6,:"LevelEnd",:"ShowTree") into GUID do 
     suspend;
   end
  end else
  if ("LevelBegin"=6) then
  begin
   for select "GUID" from "Nodes" where "OwnerGUID"=:Item into GUID do
   begin
    for select "GUID" from "ChildrenGUIDs"(:GUID,7,:"LevelEnd",:"ShowTree") into GUID do 
     suspend;
   end
  end else
  if ("LevelBegin"=7) then
  begin
   for select "GUID" from "LVFiders" where "OwnerGUID"=:Item into GUID do
   begin
    for select "GUID" from "ChildrenGUIDs"(:GUID,8,:"LevelEnd",:"ShowTree") into GUID do 
     suspend;
   end
  end else
  if ("LevelBegin"=8) then
  begin
   for select "GUID" from "LVNodes" where "OwnerGUID"=:Item into GUID do
   begin
    for select "GUID" from "ChildrenGUIDs"(:GUID,9,:"LevelEnd",:"ShowTree") into GUID do 
     suspend;
   end
  end
end
^

COMMIT ^
/* Alter (GetFiderOwnerGUID) */
ALTER PROCEDURE "GetFiderOwnerGUID"("AOEnergo" INTEGER,
PES VARCHAR(50) CHARACTER SET WIN1251,
RES VARCHAR(50) CHARACTER SET WIN1251,
"Center" VARCHAR(50) CHARACTER SET WIN1251,
"Section" VARCHAR(8) CHARACTER SET WIN1251,
"Unom" DECIMAL(10,2))
 RETURNS("OwnerGUID" INTEGER)
 AS
declare variable isNew smallint;
declare variable "OwnerGUID2" integer;
BEGIN
 isNew=0;"OwnerGUID"="AOEnergo";"OwnerGUID2"=null;
/*AOEnergo OwnerGUID*
 select "GUID" from "AOEnergo" where "Name"=:"AOEnergo" into :"OwnerGUID";
 if ("OwnerGUID" is NULL) then
 begin
  isNew=1;
  execute procedure "InsertAOEnergo"(:"AOEnergo") RETURNING_VALUES "OwnerGUID";
 end
/*PES OwnerGUID2*/
 if (isNew=0) then
  begin
   select "GUID" from "PES" where "OwnerGUID"=:"OwnerGUID" and "Name"=:"PES"
   into :"OwnerGUID2";
   if ("OwnerGUID2" is NULL) then isNew=1;
 end
 if (isNew=1) then
  execute procedure "InsertPES"(:"OwnerGUID",:"PES") RETURNING_VALUES "OwnerGUID2";
/*RES OwnerGUID*/
 else
BEGIN
   "OwnerGUID"=null;
   select "GUID" from "RES" where "OwnerGUID"=:"OwnerGUID2" and "Name"=:"RES"
   into :"OwnerGUID";
   if ("OwnerGUID" is NULL) then isNew=1;
 end
 if (isNew=1) then
  execute procedure "InsertRES"(:"OwnerGUID2",:"RES") RETURNING_VALUES "OwnerGUID";
/*Center OwnerGUID2*/
 else
   BEGIN
   "OwnerGUID2"=null;
   select "GUID" from "Centers" where "OwnerGUID"=:"OwnerGUID" and "Name"=:"Center"
   into :"OwnerGUID2";
   if ("OwnerGUID2" is NULL) then isNew=1;
 END
 if (isNew=1) then
  execute procedure "InsertCenter"(:"OwnerGUID",:"Center") RETURNING_VALUES "OwnerGUID2";
/*Section OwnerGUID*/
 else
BEGIN
   "OwnerGUID"=null;
   select "GUID" from "Sections" where "OwnerGUID"=:"OwnerGUID2" and
    "Unom"=:"Unom" and "Name"=:"Section"
   into :"OwnerGUID";
   if ("OwnerGUID" is NULL) then isNew=1;
 end
 if (isNew=1) then
  execute procedure "InsertSection"(:"OwnerGUID2",:"Section",:"Unom",null,null)
  RETURNING_VALUES "OwnerGUID";
END
^

COMMIT ^
/* Alter (GetNewItemsListsIdent) */
ALTER PROCEDURE "GetNewItemsListsIdent" RETURNS(NEW_VALUE INTEGER)
 AS
BEGIN
 NEW_VALUE = GEN_ID("ItemsListsIdent",1);
END
^

COMMIT ^
/* Alter (GetNewMainsIdent) */
ALTER PROCEDURE "GetNewMainsIdent" RETURNS(ID INTEGER)
 AS
BEGIN
 ID = GEN_ID("MainsIdent",1);
 SUSPEND;
END
^

COMMIT ^
/* Alter (InsertAOEnergo) */
ALTER PROCEDURE "InsertAOEnergo"("Name" VARCHAR(50) CHARACTER SET WIN1251,
"Region" SMALLINT)
 RETURNS(GUID INTEGER)
 AS
BEGIN
 EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES :"GUID";
 INSERT INTO "AOEnergo" ("GUID","Name","Region") VALUES (:"GUID",:"Name",:"Region");
END
^

COMMIT ^
/* Alter (LVCheckSavedFiderProc) */
ALTER PROCEDURE "LVCheckSavedFiderProc"(AGUID INTEGER)
 AS
begin
 insert into "GUID" (GUID)
 select L."Node1" from "LVLines" L
 where L."OwnerGUID"=:AGUID and
  not exists (select * from "GUID" where "GUID".guid = L."Node1");

 insert into "GUID" (GUID)
 select L."Node2" from "LVLines" L
 where L."OwnerGUID"=:AGUID and
  not exists (select * from "GUID" where "GUID".guid = L."Node2");

 insert into "LVNodes" ("GUID","OwnerGUID")
 select L."Node1",L."OwnerGUID" from "LVLines" L
 where L."OwnerGUID"=:AGUID and
  not exists (select * from "LVNodes" where "LVNodes".guid = L."Node1");

 insert into "LVNodes" ("GUID","OwnerGUID")
 select L."Node2",L."OwnerGUID" from "LVLines" L
 where L."OwnerGUID"=:AGUID and
  not exists (select * from "LVNodes" where "LVNodes".guid = L."Node2");

 insert into "Coors" (guid,x,y)
 select N.GUID,200,200 from "LVNodes" N
 where N."OwnerGUID"=:AGUID and
  not exists (select * from "Coors" C where C.GUID=N.GUID);
end
^

COMMIT ^
/* Alter (UpdateRelationIDs) */
ALTER PROCEDURE "UpdateRelationIDs" AS
declare variable AGUID integer;
declare variable ARelationID integer;
begin
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='AOEnergo'
 into ARelationID;
 for 
  select "AOEnergo"."GUID" from "AOEnergo"
  inner join "GUID" on ("GUID"."GUID"="AOEnergo"."GUID")
  where ("GUID"."RELATION_ID" IS NULL OR "GUID"."RELATION_ID"<>:ARelationID) into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end

 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='PES'
 into ARelationID;
 for 
  select "PES"."GUID" from "PES"
  inner join "GUID" on ("GUID"."GUID"="PES"."GUID")
  where ("GUID"."RELATION_ID" IS NULL OR "GUID"."RELATION_ID"<>:ARelationID) into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end

 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='RES'
 into ARelationID;
 for 
  select "RES"."GUID" from "RES"
  inner join "GUID" on ("GUID"."GUID"="RES"."GUID")
  where ("GUID"."RELATION_ID" IS NULL OR "GUID"."RELATION_ID"<>:ARelationID) into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Centers'
 into ARelationID;
 for
  select "Centers"."GUID" from "Centers"
  inner join "GUID" on ("GUID"."GUID"="Centers"."GUID")
  where ("GUID"."RELATION_ID" IS NULL OR "GUID"."RELATION_ID"<>:ARelationID) into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Sections'
 into ARelationID;
 for 
  select "Sections"."GUID" from "Sections"
  inner join "GUID" on ("GUID"."GUID"="Sections"."GUID")
  where ("GUID"."RELATION_ID" IS NULL OR "GUID"."RELATION_ID"<>:ARelationID) into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Fiders'
 into ARelationID;
 for 
  select "Fiders"."GUID" from "Fiders"
  inner join "GUID" on ("GUID"."GUID"="Fiders"."GUID")
  where ("GUID"."RELATION_ID" IS NULL OR "GUID"."RELATION_ID"<>:ARelationID) into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end

 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Nodes'
 into ARelationID;
 for 
  select "Nodes"."GUID" from "Nodes"
  inner join "GUID" on ("GUID"."GUID"="Nodes"."GUID")
  where ("GUID"."RELATION_ID" IS NULL OR "GUID"."RELATION_ID"<>:ARelationID) and "Nodes"."GUID"<>"Nodes"."OwnerGUID"
  into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Nodes3'
 into ARelationID;
 for 
  select "Nodes3"."GUID_CH" from "Nodes3"
  inner join "GUID" on ("GUID"."GUID"="Nodes3"."GUID_CH")
  where ("GUID"."RELATION_ID" IS NULL OR "GUID"."RELATION_ID"<>:ARelationID) into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end

 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Lines'
 into ARelationID;
 for
  select "Lines"."GUID" from "Lines"
  inner join "GUID" on ("GUID"."GUID"="Lines"."GUID")
  where ("GUID"."RELATION_ID" IS NULL OR "GUID"."RELATION_ID"<>:ARelationID) into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end

 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='LVFiders'
 into ARelationID;
 for 
  select "LVFiders"."GUID" from "LVFiders"
  inner join "GUID" on ("GUID"."GUID"="LVFiders"."GUID")
  where ("GUID"."RELATION_ID" IS NULL OR "GUID"."RELATION_ID"<>:ARelationID) into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end

 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='LVNodes'
 into ARelationID;
 for
  select "LVNodes"."GUID" from "LVNodes"
  inner join "GUID" on ("GUID"."GUID"="LVNodes"."GUID")
  where ("GUID"."RELATION_ID" IS NULL OR "GUID"."RELATION_ID"<>:ARelationID) and "LVNodes"."GUID"<>"LVNodes"."OwnerGUID"
  into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='LVLines'
 into ARelationID;
 for 
  select "LVLines"."GUID" from "LVLines"
  inner join "GUID" on ("GUID"."GUID"="LVLines"."GUID")
  where ("GUID"."RELATION_ID" IS NULL OR "GUID"."RELATION_ID"<>:ARelationID) into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end

 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='BalanceObjects'
 into ARelationID;
 for 
  select "BalanceObjects"."GUID" from "BalanceObjects"
  inner join "GUID" on ("GUID"."GUID"="BalanceObjects"."GUID")
  where ("GUID"."RELATION_ID" IS NULL OR "GUID"."RELATION_ID"<>:ARelationID) into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='LVConsumersA'
 into ARelationID;
 for 
  select "LVConsumersA"."GUID" from "LVConsumersA"
  inner join "GUID" on ("GUID"."GUID"="LVConsumersA"."GUID")
  where ("GUID"."RELATION_ID" IS NULL OR "GUID"."RELATION_ID"<>:ARelationID) into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='IntStLoads'
 into ARelationID;
 for
  select "IntStLoads"."GUID" from "IntStLoads"
  inner join "GUID" on ("GUID"."GUID"="IntStLoads"."GUID")
  where ("GUID"."RELATION_ID" IS NULL OR "GUID"."RELATION_ID"<>:ARelationID) into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='MainsNodes'
 into ARelationID;
 for
  select "MainsNodes"."GUID" from "MainsNodes"
  inner join "GUID" on ("GUID"."GUID"="MainsNodes"."GUID")
  where ("GUID"."RELATION_ID" IS NULL OR "GUID"."RELATION_ID"<>:ARelationID) 
  into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='MainsLines'
 into ARelationID;
 for 
  select "MainsLines"."GUID" from "MainsLines"
  inner join "GUID" on ("GUID"."GUID"="MainsLines"."GUID")
  where ("GUID"."RELATION_ID" IS NULL OR "GUID"."RELATION_ID"<>:ARelationID) into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
end
^

COMMIT ^
/* Create Trigger... */
CREATE TRIGGER "WeatherConditionsBeforeInsert" FOR "WeatherConditions"
ACTIVE BEFORE INSERT POSITION 0 
AS
BEGIN
 IF (NEW."Ident" IS NULL) THEN NEW."Ident"=GEN_ID("WeatherConditionIdent",1);
END
^

COMMIT ^

/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "AOEnergoInsertTrigger";

COMMIT;
SET TERM ^ ;

CREATE TRIGGER "AOEnergoInsertTrigger" FOR "AOEnergo"
ACTIVE BEFORE INSERT POSITION 0 
AS
BEGIN
 IF (NEW."GUID" IS NULL OR NEW."GUID"=0) THEN
  EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES NEW."GUID";
 UPDATE "GUID" SET "RELATION_ID"=
  (SELECT "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='AOEnergo')
 WHERE "GUID"=NEW."GUID";
END
^

COMMIT ^
/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "CenterInsertTrigger";

COMMIT;
SET TERM ^ ;

CREATE TRIGGER "CenterInsertTrigger" FOR "Centers"
ACTIVE BEFORE INSERT POSITION 0 
AS
BEGIN
 IF (NEW."GUID" IS NULL OR NEW."GUID"=0) THEN
  EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES NEW."GUID";
 UPDATE "GUID" SET "RELATION_ID"=
  (SELECT "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Centers')
 WHERE "GUID"=NEW."GUID";
END
^

COMMIT ^
/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "ExLinesBeforeInsertTrigger";

COMMIT;
SET TERM ^ ;

CREATE TRIGGER "ExLinesBeforeInsertTrigger" FOR "ExLines"
ACTIVE BEFORE INSERT POSITION 0 
AS
DECLARE VARIABLE OwnerGUID1 INTEGER;
DECLARE VARIABLE OwnerGUID2 INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Nodes" WHERE "GUID"=NEW."GUID1" INTO :OwnerGUID1;
 SELECT "OwnerGUID" FROM "Nodes" WHERE "GUID"=NEW."GUID2" INTO :OwnerGUID2;
 IF (OwnerGUID1=OwnerGUID2) THEN EXCEPTION "ExLinesError";
END
^

COMMIT ^
/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "FiderInsertTrigger";

COMMIT;
SET TERM ^ ;

CREATE TRIGGER "FiderInsertTrigger" FOR "Fiders"
ACTIVE BEFORE INSERT POSITION 0 
AS
BEGIN
 IF (NEW."GUID" IS NULL OR NEW."GUID"=0) THEN
  EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES NEW."GUID";
 UPDATE "GUID" SET "RELATION_ID"=
  (SELECT "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Fiders')
 WHERE "GUID"=NEW."GUID";
END
^

COMMIT ^
/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "LinesBeforeInsertTrigger";

COMMIT;
SET TERM ^ ;

CREATE TRIGGER "LinesBeforeInsertTrigger" FOR "Lines"
ACTIVE BEFORE INSERT POSITION 0 
AS
BEGIN
 IF (NEW."GUID" IS NULL OR NEW."GUID"=0) THEN
  EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES NEW."GUID";
 UPDATE "GUID" SET "RELATION_ID"=
  (SELECT "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Lines')
 WHERE "GUID"=NEW."GUID";
END
^

COMMIT ^
/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "MeterCount_BI";

COMMIT;
SET TERM ^ ;

CREATE TRIGGER "MeterCount_BI" FOR "MeterCount"
ACTIVE BEFORE INSERT POSITION 0 
AS
BEGIN
  IF (NEW."Ident" IS NULL) THEN
      NEW."Ident" = GEN_ID("MeterCount_Ident_GEN",1);
END
^

COMMIT ^
/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "MeterRecords_BI";

COMMIT;
SET TERM ^ ;

CREATE TRIGGER "MeterRecords_BI" FOR "MeterRecords"
ACTIVE BEFORE INSERT POSITION 0 
AS
BEGIN
  IF (NEW."Ident" IS NULL) THEN
      NEW."Ident" = GEN_ID("MeterRecords_Ident_GEN",1);
END
^

COMMIT ^
/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "NodePResultsDeleteTrigger";

COMMIT;
SET TERM ^ ;

CREATE TRIGGER "NodePResultsDeleteTrigger" FOR "PResults"
ACTIVE AFTER UPDATE OR DELETE POSITION 0 
AS
BEGIN
 DELETE FROM "PResultsPN"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT N."GUID" FROM "Nodes" N
   INNER JOIN "Fiders" F ON (F."GUID"=N."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");
 DELETE FROM "PResultsPN3"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT N."GUID" FROM "Nodes" N
   INNER JOIN "Fiders" F ON (F."GUID"=N."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");
 DELETE FROM "PResultsPL"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT L."GUID" FROM "Lines" L
   INNER JOIN "Fiders" F ON (F."GUID"=L."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");

 DELETE FROM "PResultsWN"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT N."GUID" FROM "Nodes" N
   INNER JOIN "Fiders" F ON (F."GUID"=N."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");
 DELETE FROM "PResultsWN3"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT N."GUID" FROM "Nodes" N
   INNER JOIN "Fiders" F ON (F."GUID"=N."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");
 DELETE FROM "PResultsWL"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT L."GUID" FROM "Lines" L
   INNER JOIN "Fiders" F ON (F."GUID"=L."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");
END
^

COMMIT ^
/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "NodesBeforeInsertTrigger";

COMMIT;
SET TERM ^ ;

CREATE TRIGGER "NodesBeforeInsertTrigger" FOR "Nodes"
ACTIVE BEFORE INSERT POSITION 0 
AS
BEGIN
 IF (NEW."GUID" IS NULL OR NEW."GUID"=0) THEN
  EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES NEW."GUID";
 IF (NEW."GUID"<>NEW."OwnerGUID") THEN
  UPDATE "GUID" SET "RELATION_ID"=
   (SELECT "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Nodes')
 WHERE "GUID"=NEW."GUID";
END
^

COMMIT ^
/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "NodesBeforeUpdateTrigger";

COMMIT;
SET TERM ^ ;

CREATE TRIGGER "NodesBeforeUpdateTrigger" FOR "Nodes"
ACTIVE BEFORE UPDATE POSITION 0 
AS
DECLARE VARIABLE ReferenceType Smallint;
DECLARE VARIABLE MaxPositionOtp Smallint;
DECLARE VARIABLE MaxPositionOtpC Smallint;
BEGIN
 MaxPositionOtp=0;
 IF (NEW."Transf"<>OLD."Transf") THEN
  IF (NEW."Transf"<=0) THEN NEW."PositionOtp"=0;
  ELSE
   BEGIN
    SELECT "ReferenceType" FROM "References" WHERE "Ident"=OLD."Transf"
    INTO :ReferenceType;
    IF (ReferenceType IN (6,7)) THEN
     BEGIN
      IF (ReferenceType=6) THEN
       SELECT "NumberOtpB","NumberOtpC" FROM "Transforms3" WHERE "Ident"=NEW."Transf"
       INTO :MaxPositionOtp,:MaxPositionOtpC;  ELSE
      IF (ReferenceType=7) THEN
       SELECT "NumberOtpB","NumberOtpC" FROM "TransformsA" WHERE "Ident"=NEW."Transf"
       INTO :MaxPositionOtp,:MaxPositionOtpC;

      IF ("Mask"(NEW."PositionOtp",127)>MaxPositionOtp)
       THEN NEW."PositionOtp"="Mask"(NEW."PositionOtp",65408)+MaxPositionOtp;
      IF ("Mask"("ShiftR"(NEW."PositionOtp",8),127)>MaxPositionOtpC)
       THEN NEW."PositionOtp"="Mask"(NEW."PositionOtp",-32513)+"ShiftL"(MaxPositionOtp,8);
     END
    ELSE
     BEGIN
      IF (ReferenceType=4) THEN
       SELECT "NumberOtp" FROM "Transforms2" WHERE "Ident"=NEW."Transf" INTO :MaxPositionOtp;
      ELSE
       SELECT "NumberOtp" FROM "TransformsSS" WHERE "Ident"=NEW."Transf" INTO :MaxPositionOtp;
      IF (NEW."PositionOtp">MaxPositionOtp) THEN NEW."PositionOtp"=MaxPositionOtp; ELSE
      IF (NEW."PositionOtp"<-MaxPositionOtp) THEN NEW."PositionOtp"=-MaxPositionOtp;
    END
 END
END
^

COMMIT ^
/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "NodeWResultsADeleteTrigger";

COMMIT;
SET TERM ^ ;

CREATE TRIGGER "NodeWResultsADeleteTrigger" FOR "WResultsA"
ACTIVE AFTER UPDATE OR DELETE POSITION 0 
AS
BEGIN
 DELETE FROM "WResultsPN"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT N."GUID" FROM "Nodes" N
   INNER JOIN "Fiders" F ON (F."GUID"=N."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");
 DELETE FROM "WResultsPN3"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT N."GUID" FROM "Nodes" N
   INNER JOIN "Fiders" F ON (F."GUID"=N."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");
 DELETE FROM "WResultsPL"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT L."GUID" FROM "Lines" L
   INNER JOIN "Fiders" F ON (F."GUID"=L."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");

 DELETE FROM "WResultsWN"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT N."GUID" FROM "Nodes" N
   INNER JOIN "Fiders" F ON (F."GUID"=N."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");
 DELETE FROM "WResultsWN3"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT N."GUID" FROM "Nodes" N
   INNER JOIN "Fiders" F ON (F."GUID"=N."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");
 DELETE FROM "WResultsWL"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT L."GUID" FROM "Lines" L
   INNER JOIN "Fiders" F ON (F."GUID"=L."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");
END
^

COMMIT ^
/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "NodeWResultsDeleteTrigger";

COMMIT;
SET TERM ^ ;

CREATE TRIGGER "NodeWResultsDeleteTrigger" FOR "WResults"
ACTIVE AFTER UPDATE OR DELETE POSITION 0 
AS
BEGIN
 DELETE FROM "WResultsPN"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT N."GUID" FROM "Nodes" N
   INNER JOIN "Fiders" F ON (F."GUID"=N."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");
 DELETE FROM "WResultsPN3"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT N."GUID" FROM "Nodes" N
   INNER JOIN "Fiders" F ON (F."GUID"=N."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");
 DELETE FROM "WResultsPL"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT L."GUID" FROM "Lines" L
   INNER JOIN "Fiders" F ON (F."GUID"=L."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");

 DELETE FROM "WResultsWN"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT N."GUID" FROM "Nodes" N
   INNER JOIN "Fiders" F ON (F."GUID"=N."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");
 DELETE FROM "WResultsWN3"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT N."GUID" FROM "Nodes" N
   INNER JOIN "Fiders" F ON (F."GUID"=N."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");
 DELETE FROM "WResultsWL"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT L."GUID" FROM "Lines" L
   INNER JOIN "Fiders" F ON (F."GUID"=L."OwnerGUID")
   WHERE F."GUID"=OLD."GUID");
END
^

COMMIT ^
/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "PESInsertTrigger";

COMMIT;
SET TERM ^ ;

CREATE TRIGGER "PESInsertTrigger" FOR PES
ACTIVE BEFORE INSERT POSITION 0 
AS
BEGIN
 IF (NEW."GUID" IS NULL OR NEW."GUID"=0)  THEN
  EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES NEW."GUID";
 UPDATE "GUID" SET "RELATION_ID"=
  (SELECT "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='PES')
 WHERE "GUID"=NEW."GUID";
END
^

COMMIT ^
/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "ResInsertTrigger";

COMMIT;
SET TERM ^ ;

CREATE TRIGGER "ResInsertTrigger" FOR RES
ACTIVE BEFORE INSERT POSITION 0 
AS
BEGIN
 IF (NEW."GUID" IS NULL OR NEW."GUID"=0) THEN
  EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES NEW."GUID";
 UPDATE "GUID" SET "RELATION_ID"=
  (SELECT "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='RES')
 WHERE "GUID"=NEW."GUID";
END
^

COMMIT ^
/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "SectionsAfterDeleteTrigger";

COMMIT;
SET TERM ^ ;

CREATE TRIGGER "SectionsAfterDeleteTrigger" FOR "Sections"
ACTIVE AFTER DELETE POSITION 0 
AS
  BEGIN
 DELETE FROM "GUID" WHERE "GUID"=OLD."GUID";
END
^

COMMIT ^
/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "SectionsInsertTrigger";

COMMIT;
SET TERM ^ ;

CREATE TRIGGER "SectionsInsertTrigger" FOR "Sections"
ACTIVE BEFORE INSERT POSITION 0 
AS
BEGIN
 IF (NEW."GUID" IS NULL OR NEW."GUID"=0) THEN
  EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES NEW."GUID";
 UPDATE "GUID" SET "RELATION_ID"=
  (SELECT "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Sections')
 WHERE "GUID"=NEW."GUID";
END
^

COMMIT ^
/* DROP: -- GRANT EXECUTE ON PROCEDURE "AOEnergoInsertProc" TO "rtp3user" */
SET TERM ; ^


COMMIT;

ALTER DOMAIN "DECIMAL_Temperature_NOT_NULL" TYPE DECIMAL(6,3);
ALTER TABLE "LVPResults" ALTER COLUMN UA TYPE DECIMAL_6_3;
ALTER TABLE "LVPResults" ALTER COLUMN UB TYPE DECIMAL_6_3;
ALTER TABLE "LVPResults" ALTER COLUMN UC TYPE DECIMAL_6_3;
ALTER TABLE "LVPResults" ALTER COLUMN IA TYPE DECIMAL_6_3;
ALTER TABLE "LVPResults" ALTER COLUMN IB TYPE DECIMAL_6_3;
ALTER TABLE "LVPResults" ALTER COLUMN IC TYPE DECIMAL_6_3;
ALTER TABLE "LVPResults" ALTER COLUMN U2A TYPE DECIMAL_6_3;
ALTER TABLE "LVPResults" ALTER COLUMN U2B TYPE DECIMAL_6_3;
ALTER TABLE "LVPResults" ALTER COLUMN U2C TYPE DECIMAL_6_3;
/*ALTER TABLE "LVPSamples" ALTER COLUMN T TYPE DECIMAL_7_3; */
/*ALTER TABLE "LVPTPInfo" ALTER COLUMN T TYPE DECIMAL_7_3;  */
ALTER TABLE "LVWResults" ALTER COLUMN UA TYPE DECIMAL_6_3;
ALTER TABLE "LVWResults" ALTER COLUMN UB TYPE DECIMAL_6_3;
ALTER TABLE "LVWResults" ALTER COLUMN UC TYPE DECIMAL_6_3;
ALTER TABLE "LVWResults" ALTER COLUMN IA TYPE DECIMAL_6_3;
ALTER TABLE "LVWResults" ALTER COLUMN IB TYPE DECIMAL_6_3;
ALTER TABLE "LVWResults" ALTER COLUMN IC TYPE DECIMAL_6_3;
ALTER TABLE "LVWResults" ALTER COLUMN "ImaxA" TYPE DECIMAL_6_3;
ALTER TABLE "LVWResults" ALTER COLUMN "ImaxB" TYPE DECIMAL_6_3;
ALTER TABLE "LVWResults" ALTER COLUMN "ImaxC" TYPE DECIMAL_6_3;
ALTER TABLE "LVWResults" ALTER COLUMN "IminA" TYPE DECIMAL_6_3;
ALTER TABLE "LVWResults" ALTER COLUMN "IminB" TYPE DECIMAL_6_3;
ALTER TABLE "LVWResults" ALTER COLUMN "IminC" TYPE DECIMAL_6_3;
ALTER TABLE "LVWResults" ALTER COLUMN U2A TYPE DECIMAL_6_3;
ALTER TABLE "LVWResults" ALTER COLUMN U2B TYPE DECIMAL_6_3;
ALTER TABLE "LVWResults" ALTER COLUMN U2C TYPE DECIMAL_6_3;

update RDB$RELATION_FIELDS set RDB$FIELD_SOURCE = 'DECIMAL_7_3'
where (RDB$FIELD_NAME = 'T') and (RDB$RELATION_NAME = 'LVWResults') ;

/*ALTER TABLE "LVWResults" ALTER COLUMN T TYPE DECIMAL_7_3;  */
ALTER TABLE "LVWResultsB" DROP CONSTRAINT "CHECK_LVWResultsB_T";
ALTER TABLE "LVWResultsB" ALTER COLUMN T TYPE DECIMAL_7_3;

update RDB$RELATION_FIELDS set RDB$FIELD_SOURCE = 'DECIMAL_7_3'
where (RDB$FIELD_NAME = 'T') and (RDB$RELATION_NAME = 'LVWSamples') ;

/*ALTER TABLE "LVWSamples" ALTER COLUMN T TYPE DECIMAL_7_3; */
ALTER TABLE "MainsWLoads" ALTER COLUMN T TYPE DECIMAL_7_3;
ALTER TABLE "PResults" ALTER COLUMN "Kzag" TYPE DECIMAL_6_3_NOT_NULL;
ALTER TABLE "PResults"  ADD "dU"  DECIMAL_6_3_NOT_NULL;
ALTER TABLE "PResults" ALTER COLUMN "Ssum_tr_OnBalance" TYPE DECIMAL_10_3_NOT_NULL;
ALTER TABLE "PResults" ALTER COLUMN "Ssum_tr_NotBalance" TYPE DECIMAL_10_3_NOT_NULL;
ALTER TABLE "WLoads" ALTER COLUMN T TYPE DECIMAL_7_3;
ALTER TABLE "WResults" ALTER COLUMN T TYPE DECIMAL_7_3;
ALTER TABLE "WResults" ALTER COLUMN "Imax" TYPE DECIMAL_9_3;
ALTER TABLE "WResults" ALTER COLUMN "Ssum_tr_OnBalance" TYPE DECIMAL_10_3_NOT_NULL;
ALTER TABLE "WResults" ALTER COLUMN "Ssum_tr_NotBalance" TYPE DECIMAL_10_3_NOT_NULL;
ALTER TABLE "WResults" ALTER COLUMN "Kzag" TYPE DECIMAL_6_3_NOT_NULL;
ALTER TABLE "WResults"  ADD "dU" DECIMAL_6_3_NOT_NULL;
ALTER TABLE "WResultsA" ALTER COLUMN T TYPE DECIMAL_7_3;
ALTER TABLE "WResultsA" ALTER COLUMN "Imax" TYPE DECIMAL_9_3;
ALTER TABLE "WResultsA" ALTER COLUMN "Ssum_tr_OnBalance" TYPE DECIMAL_10_3_NOT_NULL;
ALTER TABLE "WResultsA" ALTER COLUMN "Ssum_tr_NotBalance" TYPE DECIMAL_10_3_NOT_NULL;
ALTER TABLE "WResultsA" ALTER COLUMN "Kzag" TYPE DECIMAL_6_3_NOT_NULL;
ALTER TABLE "WResultsA"  ADD "dU" DECIMAL_6_3_NOT_NULL;
ALTER TABLE "WSamples" ALTER COLUMN T TYPE DECIMAL_7_3;
COMMIT ;

ALTER TABLE "WResults" ADD "Pgy" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "Qgy" NUMBER_9_3;
ALTER TABLE "WResults" ADD "dPnlin_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "dPnlin_notBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "dPklin_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "dPklin_notBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "dPcrown_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "dPcrown_notBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "dQnlin_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "dQnlin_notBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "dPntr_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "dPntr_notBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "dQntr_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "dQntr_notBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "dPxx_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "dPxx_notBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "dQxx_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "dQxx_notBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "Qc_onBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "Qc_notBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "Ppotr_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "Ppotr_notBalance" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "Qpotr_OnBalance" NUMBER_9_3;
ALTER TABLE "WResults" ADD "Qpotr_notBalance" NUMBER_9_3;
ALTER TABLE "WResults" ADD "Ppotr_OnBalance_fact" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "Ppotr_notBalance_fact" DECIMAL_9_3;
ALTER TABLE "WResults" ADD "Qpotr_OnBalance_fact" NUMBER_9_3;
ALTER TABLE "WResults" ADD "Qpotr_notBalance_fact" NUMBER_9_3;
ALTER TABLE "WResultsA" ADD "Pgy" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "Qgy" NUMBER_9_3;
ALTER TABLE "WResultsA" ADD "dPnlin_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "dPnlin_notBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "dPklin_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "dPklin_notBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "dPcrown_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "dPcrown_notBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "dQnlin_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "dQnlin_notBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "dPntr_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "dPntr_notBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "dQntr_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "dQntr_notBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "dPxx_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "dPxx_notBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "dQxx_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "dQxx_notBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "Qc_onBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "Qc_notBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "Ppotr_OnBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "Ppotr_notBalance" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "Qpotr_OnBalance" NUMBER_9_3;
ALTER TABLE "WResultsA" ADD "Qpotr_notBalance" NUMBER_9_3;
ALTER TABLE "WResultsA" ADD "Ppotr_OnBalance_fact" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "Ppotr_notBalance_fact" DECIMAL_9_3;
ALTER TABLE "WResultsA" ADD "Qpotr_OnBalance_fact" NUMBER_9_3;
ALTER TABLE "WResultsA" ADD "Qpotr_notBalance_fact" NUMBER_9_3;

ALTER TABLE "WResults" ALTER COLUMN "SampleIdent" POSITION 1;
ALTER TABLE "WResults" ALTER COLUMN GUID POSITION 2;
ALTER TABLE "WResults" ALTER COLUMN "Wa" POSITION 3;
ALTER TABLE "WResults" ALTER COLUMN "Wr" POSITION 4;
ALTER TABLE "WResults" ALTER COLUMN T POSITION 5;
ALTER TABLE "WResults" ALTER COLUMN U POSITION 6;
ALTER TABLE "WResults" ALTER COLUMN "Imax" POSITION 7;
ALTER TABLE "WResults" ALTER COLUMN "Kzap" POSITION 8;
ALTER TABLE "WResults" ALTER COLUMN "sqrKfg" POSITION 9;
ALTER TABLE "WResults" ALTER COLUMN "sqrKfgCalc" POSITION 10;
ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_onBalance" POSITION 11;
ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_notBalance" POSITION 12;
ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_onBalance" POSITION 13;
ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_notBalance" POSITION 14;
ALTER TABLE "WResults" ALTER COLUMN "DWal_cu_onBalance" POSITION 15;
ALTER TABLE "WResults" ALTER COLUMN "DWal_cu_notBalance" POSITION 16;
ALTER TABLE "WResults" ALTER COLUMN "DWal_k_onBalance" POSITION 17;
ALTER TABLE "WResults" ALTER COLUMN "DWal_k_notBalance" POSITION 18;
ALTER TABLE "WResults" ALTER COLUMN "DWal_crown_OnBalance" POSITION 19;
ALTER TABLE "WResults" ALTER COLUMN "DWal_crown_notBalance" POSITION 20;
ALTER TABLE "WResults" ALTER COLUMN "DWrl_cu_onBalance" POSITION 21;
ALTER TABLE "WResults" ALTER COLUMN "DWrl_cu_notBalance" POSITION 22;
ALTER TABLE "WResults" ALTER COLUMN "DWcu_onBalance" POSITION 23;
ALTER TABLE "WResults" ALTER COLUMN "DWcu_notBalance" POSITION 24;
ALTER TABLE "WResults" ALTER COLUMN "DWrcu_onBalance" POSITION 25;
ALTER TABLE "WResults" ALTER COLUMN "DWrcu_notBalance" POSITION 26;
ALTER TABLE "WResults" ALTER COLUMN "DWxx_onBalance" POSITION 27;
ALTER TABLE "WResults" ALTER COLUMN "DWxx_notBalance" POSITION 28;
ALTER TABLE "WResults" ALTER COLUMN "DWrxx_onBalance" POSITION 29;
ALTER TABLE "WResults" ALTER COLUMN "DWrxx_notBalance" POSITION 30;
ALTER TABLE "WResults" ALTER COLUMN "Wrc_onBalance" POSITION 31;
ALTER TABLE "WResults" ALTER COLUMN "Wrc_notBalance" POSITION 32;
ALTER TABLE "WResults" ALTER COLUMN "Ssum_tr_OnBalance" POSITION 33;
ALTER TABLE "WResults" ALTER COLUMN "Ssum_tr_NotBalance" POSITION 34;
ALTER TABLE "WResults" ALTER COLUMN "Ntr_OnBalance" POSITION 35;
ALTER TABLE "WResults" ALTER COLUMN "Ntr_NotBalance" POSITION 36;
ALTER TABLE "WResults" ALTER COLUMN "LsumP_OnBalance" POSITION 37;
ALTER TABLE "WResults" ALTER COLUMN "LsumP_NotBalance" POSITION 38;
ALTER TABLE "WResults" ALTER COLUMN "LsumC_OnBalance" POSITION 39;
ALTER TABLE "WResults" ALTER COLUMN "LsumC_NotBalance" POSITION 40;
ALTER TABLE "WResults" ALTER COLUMN "NLineP_OnBalance" POSITION 41;
ALTER TABLE "WResults" ALTER COLUMN "NLineP_NotBalance" POSITION 42;
ALTER TABLE "WResults" ALTER COLUMN "NLineC_OnBalance" POSITION 43;
ALTER TABLE "WResults" ALTER COLUMN "NLineC_NotBalance" POSITION 44;
ALTER TABLE "WResults" ALTER COLUMN "NAbonents_OnBalance" POSITION 45;
ALTER TABLE "WResults" ALTER COLUMN "NAbonents_NotBalance" POSITION 46;
ALTER TABLE "WResults" ALTER COLUMN "Kzag" POSITION 47;
ALTER TABLE "WResults" ALTER COLUMN "dU" POSITION 48;
ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_onBalance_fact" POSITION 49;
ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_notBalance_fact" POSITION 50;
ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_onBalance_fact" POSITION 51;
ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_notBalance_fact" POSITION 52;
ALTER TABLE "WResults" ALTER COLUMN "Pgy" POSITION 53;
ALTER TABLE "WResults" ALTER COLUMN "Qgy" POSITION 54;
ALTER TABLE "WResults" ALTER COLUMN "dPnlin_OnBalance" POSITION 55;
ALTER TABLE "WResults" ALTER COLUMN "dPnlin_notBalance" POSITION 56;
ALTER TABLE "WResults" ALTER COLUMN "dPklin_OnBalance" POSITION 57;
ALTER TABLE "WResults" ALTER COLUMN "dPklin_notBalance" POSITION 58;
ALTER TABLE "WResults" ALTER COLUMN "dPcrown_OnBalance" POSITION 59;
ALTER TABLE "WResults" ALTER COLUMN "dPcrown_notBalance" POSITION 60;
ALTER TABLE "WResults" ALTER COLUMN "dQnlin_OnBalance" POSITION 61;
ALTER TABLE "WResults" ALTER COLUMN "dQnlin_notBalance" POSITION 62;
ALTER TABLE "WResults" ALTER COLUMN "dPntr_OnBalance" POSITION 63;
ALTER TABLE "WResults" ALTER COLUMN "dPntr_notBalance" POSITION 64;
ALTER TABLE "WResults" ALTER COLUMN "dQntr_OnBalance" POSITION 65;
ALTER TABLE "WResults" ALTER COLUMN "dQntr_notBalance" POSITION 66;
ALTER TABLE "WResults" ALTER COLUMN "dPxx_OnBalance" POSITION 67;
ALTER TABLE "WResults" ALTER COLUMN "dPxx_notBalance" POSITION 68;
ALTER TABLE "WResults" ALTER COLUMN "dQxx_OnBalance" POSITION 69;
ALTER TABLE "WResults" ALTER COLUMN "dQxx_notBalance" POSITION 70;
ALTER TABLE "WResults" ALTER COLUMN "Qc_onBalance" POSITION 71;
ALTER TABLE "WResults" ALTER COLUMN "Qc_notBalance" POSITION 72;
ALTER TABLE "WResults" ALTER COLUMN "Ppotr_OnBalance" POSITION 73;
ALTER TABLE "WResults" ALTER COLUMN "Ppotr_notBalance" POSITION 74;
ALTER TABLE "WResults" ALTER COLUMN "Qpotr_OnBalance" POSITION 75;
ALTER TABLE "WResults" ALTER COLUMN "Qpotr_notBalance" POSITION 76;
ALTER TABLE "WResults" ALTER COLUMN "Ppotr_OnBalance_fact" POSITION 77;
ALTER TABLE "WResults" ALTER COLUMN "Ppotr_notBalance_fact" POSITION 78;
ALTER TABLE "WResults" ALTER COLUMN "Qpotr_OnBalance_fact" POSITION 79;
ALTER TABLE "WResults" ALTER COLUMN "Qpotr_notBalance_fact" POSITION 80;
ALTER TABLE "WResults" ALTER COLUMN "dWdop" POSITION 81;
ALTER TABLE "WResults" ALTER COLUMN "Flags" POSITION 82;
ALTER TABLE "WResults" ALTER COLUMN "WeatherConditions" POSITION 83;
ALTER TABLE "WResults" ALTER COLUMN "Temperature" POSITION 84;
ALTER TABLE "WResults" ALTER COLUMN CRC POSITION 85;
ALTER TABLE "WResultsA" ALTER COLUMN "SampleIdent" POSITION 1;
ALTER TABLE "WResultsA" ALTER COLUMN GUID POSITION 2;
ALTER TABLE "WResultsA" ALTER COLUMN "Wa" POSITION 3;
ALTER TABLE "WResultsA" ALTER COLUMN "Wr" POSITION 4;
ALTER TABLE "WResultsA" ALTER COLUMN T POSITION 5;
ALTER TABLE "WResultsA" ALTER COLUMN U POSITION 6;
ALTER TABLE "WResultsA" ALTER COLUMN "Imax" POSITION 7;
ALTER TABLE "WResultsA" ALTER COLUMN "Kzap" POSITION 8;
ALTER TABLE "WResultsA" ALTER COLUMN "sqrKfg" POSITION 9;
ALTER TABLE "WResultsA" ALTER COLUMN "sqrKfgCalc" POSITION 10;
ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_onBalance" POSITION 11;
ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_notBalance" POSITION 12;
ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_onBalance" POSITION 13;
ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_notBalance" POSITION 14;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_cu_onBalance" POSITION 15;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_cu_notBalance" POSITION 16;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_k_onBalance" POSITION 17;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_k_notBalance" POSITION 18;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_crown_OnBalance" POSITION 19;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_crown_notBalance" POSITION 20;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrl_cu_onBalance" POSITION 21;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrl_cu_notBalance" POSITION 22;
ALTER TABLE "WResultsA" ALTER COLUMN "DWcu_onBalance" POSITION 23;
ALTER TABLE "WResultsA" ALTER COLUMN "DWcu_notBalance" POSITION 24;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrcu_onBalance" POSITION 25;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrcu_notBalance" POSITION 26;
ALTER TABLE "WResultsA" ALTER COLUMN "DWxx_onBalance" POSITION 27;
ALTER TABLE "WResultsA" ALTER COLUMN "DWxx_notBalance" POSITION 28;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrxx_onBalance" POSITION 29;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrxx_notBalance" POSITION 30;
ALTER TABLE "WResultsA" ALTER COLUMN "Wrc_onBalance" POSITION 31;
ALTER TABLE "WResultsA" ALTER COLUMN "Wrc_notBalance" POSITION 32;
ALTER TABLE "WResultsA" ALTER COLUMN "Ssum_tr_OnBalance" POSITION 33;
ALTER TABLE "WResultsA" ALTER COLUMN "Ssum_tr_NotBalance" POSITION 34;
ALTER TABLE "WResultsA" ALTER COLUMN "Ntr_OnBalance" POSITION 35;
ALTER TABLE "WResultsA" ALTER COLUMN "Ntr_NotBalance" POSITION 36;
ALTER TABLE "WResultsA" ALTER COLUMN "LsumP_OnBalance" POSITION 37;
ALTER TABLE "WResultsA" ALTER COLUMN "LsumP_NotBalance" POSITION 38;
ALTER TABLE "WResultsA" ALTER COLUMN "LsumC_OnBalance" POSITION 39;
ALTER TABLE "WResultsA" ALTER COLUMN "LsumC_NotBalance" POSITION 40;
ALTER TABLE "WResultsA" ALTER COLUMN "NLineP_OnBalance" POSITION 41;
ALTER TABLE "WResultsA" ALTER COLUMN "NLineP_NotBalance" POSITION 42;
ALTER TABLE "WResultsA" ALTER COLUMN "NLineC_OnBalance" POSITION 43;
ALTER TABLE "WResultsA" ALTER COLUMN "NLineC_NotBalance" POSITION 44;
ALTER TABLE "WResultsA" ALTER COLUMN "NAbonents_OnBalance" POSITION 45;
ALTER TABLE "WResultsA" ALTER COLUMN "NAbonents_NotBalance" POSITION 46;
ALTER TABLE "WResultsA" ALTER COLUMN "Kzag" POSITION 47;
ALTER TABLE "WResultsA" ALTER COLUMN "dU" POSITION 48;
ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_onBalance_fact" POSITION 49;
ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_notBalance_fact" POSITION 50;
ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_onBalance_fact" POSITION 51;
ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_notBalance_fact" POSITION 52;
ALTER TABLE "WResultsA" ALTER COLUMN "Pgy" POSITION 53;
ALTER TABLE "WResultsA" ALTER COLUMN "Qgy" POSITION 54;
ALTER TABLE "WResultsA" ALTER COLUMN "dPnlin_OnBalance" POSITION 55;
ALTER TABLE "WResultsA" ALTER COLUMN "dPnlin_notBalance" POSITION 56;
ALTER TABLE "WResultsA" ALTER COLUMN "dPklin_OnBalance" POSITION 57;
ALTER TABLE "WResultsA" ALTER COLUMN "dPklin_notBalance" POSITION 58;
ALTER TABLE "WResultsA" ALTER COLUMN "dPcrown_OnBalance" POSITION 59;
ALTER TABLE "WResultsA" ALTER COLUMN "dPcrown_notBalance" POSITION 60;
ALTER TABLE "WResultsA" ALTER COLUMN "dQnlin_OnBalance" POSITION 61;
ALTER TABLE "WResultsA" ALTER COLUMN "dQnlin_notBalance" POSITION 62;
ALTER TABLE "WResultsA" ALTER COLUMN "dPntr_OnBalance" POSITION 63;
ALTER TABLE "WResultsA" ALTER COLUMN "dPntr_notBalance" POSITION 64;
ALTER TABLE "WResultsA" ALTER COLUMN "dQntr_OnBalance" POSITION 65;
ALTER TABLE "WResultsA" ALTER COLUMN "dQntr_notBalance" POSITION 66;
ALTER TABLE "WResultsA" ALTER COLUMN "dPxx_OnBalance" POSITION 67;
ALTER TABLE "WResultsA" ALTER COLUMN "dPxx_notBalance" POSITION 68;
ALTER TABLE "WResultsA" ALTER COLUMN "dQxx_OnBalance" POSITION 69;
ALTER TABLE "WResultsA" ALTER COLUMN "dQxx_notBalance" POSITION 70;
ALTER TABLE "WResultsA" ALTER COLUMN "Qc_onBalance" POSITION 71;
ALTER TABLE "WResultsA" ALTER COLUMN "Qc_notBalance" POSITION 72;
ALTER TABLE "WResultsA" ALTER COLUMN "Ppotr_OnBalance" POSITION 73;
ALTER TABLE "WResultsA" ALTER COLUMN "Ppotr_notBalance" POSITION 74;
ALTER TABLE "WResultsA" ALTER COLUMN "Qpotr_OnBalance" POSITION 75;
ALTER TABLE "WResultsA" ALTER COLUMN "Qpotr_notBalance" POSITION 76;
ALTER TABLE "WResultsA" ALTER COLUMN "Ppotr_OnBalance_fact" POSITION 77;
ALTER TABLE "WResultsA" ALTER COLUMN "Ppotr_notBalance_fact" POSITION 78;
ALTER TABLE "WResultsA" ALTER COLUMN "Qpotr_OnBalance_fact" POSITION 79;
ALTER TABLE "WResultsA" ALTER COLUMN "Qpotr_notBalance_fact" POSITION 80;
ALTER TABLE "WResultsA" ALTER COLUMN "dWdop" POSITION 81;
ALTER TABLE "WResultsA" ALTER COLUMN "Flags" POSITION 82;
ALTER TABLE "WResultsA" ALTER COLUMN "WeatherConditions" POSITION 83;
ALTER TABLE "WResultsA" ALTER COLUMN "Temperature" POSITION 84;
ALTER TABLE "WResultsA" ALTER COLUMN CRC POSITION 85;
COMMIT;


UPDATE "Version" SET "Major"=3, "Minor"=0, "Release"=19,"Build"=0, "VersionDate"='NOW';
COMMIT ;

