CREATE PROCEDURE "ChildrenGUIDs" (ITEM  Integer,
       "Level" Smallint)
returns (GUID Integer)
AS 

begin
 if ("Level" is null or "Level"<1 or "Level">9)  then
 begin
  if (exists(select * from "AOEnergo" where "GUID"=:Item)) then "Level"=1;else
  if (exists(select * from "PES" where "GUID"=:Item)) then "Level"=2;else
  if (exists(select * from "RES" where "GUID"=:Item)) then "Level"=3;else
  if (exists(select * from "Centers" where "GUID"=:Item)) then "Level"=4;else
  if (exists(select * from "Sections" where "GUID"=:Item)) then "Level"=5;else
  if (exists(select * from "Fiders" where "GUID"=:Item)) then "Level"=6;else
  if (exists(select * from "Nodes" where "GUID"=:Item)) then "Level"=7;else
  if (exists(select * from "LVFiders" where "GUID"=:Item)) then "Level"=8;else
  if (exists(select * from "LVNodes" where "GUID"=:Item)) then "Level"=9;
  else exit;
 end
 GUID=Item;
 suspend;
 if ("Level"=1) then
 begin
  for select "GUID" from "PES" where "OwnerGUID"=:Item into GUID do
  begin
   for select "GUID" from "ChildrenGUIDs"(:GUID,2) into GUID do suspend;
  end
 end else
 if ("Level"=2) then
 begin
  for select "GUID" from "RES" where "OwnerGUID"=:Item into GUID do
  begin
   for select "GUID" from "ChildrenGUIDs"(:GUID,3) into GUID do suspend;
  end
 end else
 if ("Level"=3) then
 begin
  for select "GUID" from "Centers" where "OwnerGUID"=:Item into GUID do
  begin
   for select "GUID" from "ChildrenGUIDs"(:GUID,4) into GUID do suspend;
  end
 end else
 if ("Level"=4) then
 begin
  for select "GUID" from "Sections" where "OwnerGUID"=:Item into GUID do
  begin
   for select "GUID" from "ChildrenGUIDs"(:GUID,5) into GUID do suspend;
  end
 end else
 if ("Level"=5) then
 begin
  for select "GUID" from "Fiders" where "OwnerGUID"=:Item into GUID do
  begin
   for select "GUID" from "ChildrenGUIDs"(:GUID,6) into GUID do suspend;
  end
 end else
 if ("Level"=6) then
 begin
  for select "GUID" from "Nodes" where "OwnerGUID"=:Item into GUID do
  begin
   for select "GUID" from "ChildrenGUIDs"(:GUID,7) into GUID do suspend;
  end
 end else
 if ("Level"=7) then
 begin
  for select "GUID" from "LVFiders" where "OwnerGUID"=:Item into GUID do
  begin
   for select "GUID" from "ChildrenGUIDs"(:GUID,8) into GUID do suspend;
  end
 end else
 if ("Level"=8) then
 begin
  for select "GUID" from "LVNodes" where "OwnerGUID"=:Item into GUID do
  begin
   for select "GUID" from "ChildrenGUIDs"(:GUID,9) into GUID do suspend;
  end
 end
end ;
GRANT EXECUTE ON PROCEDURE "ChildrenGUIDs" TO "rtp3user" ;

